/*
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */
package org.apache.beehive.netui.compiler.model;

import org.w3c.dom.Element;

/**
 * Defines general support for elements that
 */
public abstract class StrutsElementSupport extends XmlElementSupport
{
    private StrutsApp _parentApp;
    private String _className;

    public StrutsElementSupport( StrutsApp parentApp )
    {
        _parentApp = parentApp;
    }

    protected StrutsApp getParentApp()
    {
        return _parentApp;
    }

    public String getClassName()
    {
        return _className;
    }

    public void setClassName( String className )
    {
        _className = className;
    }

    protected void setParentApp( StrutsApp parentApp )
    {
        _parentApp = parentApp;
    }
    
    protected final void setCustomProperty(XmlModelWriter xw, Element element, String propertyName, String value,
                                           String changeElementClassName)
    {
        if (value != null) {
            Element setPropertyElement = findChildElement(xw, element, "set-property", "property", propertyName, true);
            setPropertyElement.setAttribute("property", propertyName);
            setElementAttributeMayBeEmpty(setPropertyElement, "value", value);
            setElementAttribute(element, "className", changeElementClassName);
        }
    }
}
