/*
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */
package org.apache.beehive.netui.pageflow.handler;

import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.config.ModuleConfig;
import org.apache.beehive.netui.pageflow.PreviousPageInfo;
import org.apache.beehive.netui.pageflow.PageFlowController;
import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.PageFlowStack;
import org.apache.beehive.netui.pageflow.interceptor.action.ActionInterceptor;

/**
 * Handler for action forward processing.
 */ 
public interface ActionForwardHandler
        extends Handler
{
    ActionForward doForward( FlowControllerHandlerContext context, ActionForward fwd, ActionMapping mapping, 
                             String actionName, ModuleConfig altModuleConfig, ActionForm form );

    ActionForward doAutoViewRender( FlowControllerHandlerContext context, ActionMapping mapping, ActionForm form );

    ActionForward doReturnToPage( FlowControllerHandlerContext context, PreviousPageInfo prevPageInfo,
                                  PageFlowController currentPageFlow, ActionForm currentForm,
                                  String actionName, Forward pageFlowFwd );

    ActionForward doReturnToAction( FlowControllerHandlerContext context, String actionName, Forward pageFlowFwd );

    ActionForward doNestingReturn( FlowControllerHandlerContext context, Forward pageFlowFwd, 
                                   ActionMapping mapping, ActionForm form );

    ActionForward handleInterceptorReturn( FlowControllerHandlerContext context, PageFlowController poppedPageFlow,
                                           PageFlowStack.PushedPageFlow pushedPageFlowWrapper, String returnAction,
                                           ActionMapping actionMapping, ActionForm form, ActionInterceptor interceptor );
}
