<%@ page language="java" contentType="text/html;charset=UTF-8" %>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@ page import="org.apache.beehive.netui.datagrid.services.FilterService" %>
<%@ page import="org.apache.beehive.netui.datagrid.model.IFilter" %>
<netui:html>
<%
String filterExpr = request.getParameter("_column");
pageContext.setAttribute("filterExpr", filterExpr);
String gridName = request.getParameter("_grid");
FilterService filterSvc = FilterService.getInstance(pageContext.getRequest(), gridName, request.getParameter("_search"));
String qpOmitFilter = null;
String qpOmitAllFilters = null;
String search = request.getParameter("_search");
String filterAction = request.getParameter("_filterAction");
String prefix = request.getParameter("_prefix");
String queryStringOmitCurrentColumn = null;
IFilter[] filters = filterSvc.getFilters(filterExpr);
IFilter filter1 = (filters != null && filters.length >= 1 ? filters[0] : null);
IFilter filter2 = (filters != null && filters.length >= 2 ? filters[1] : null);

try
{
pageContext.setAttribute("filters", filters);

qpOmitFilter = filterSvc.getFilterQueryStringOmitFilter(filterExpr);
pageContext.setAttribute("qpOmitFilter", qpOmitFilter);

qpOmitAllFilters = filterSvc.getFilterQueryStringOmitAllFilters();
pageContext.setAttribute("qpOmitAllFilters", qpOmitAllFilters);

queryStringOmitCurrentColumn = filterSvc.getFilterQueryStringOmitFilter(filterExpr);
}
catch(Exception e) {e.printStackTrace();}
%>
  <head>
    <title>Filter</title>
    <script language="javascript" TYPE="text/javascript" src="_filter.js"></script>
    <script language="javascript" type="text/javascript">
var filterAction = "<%= filterAction %>";
var search = "<%= search %>";
var gridName = "<%= gridName %>";
var filterExpr = "<%= filterExpr %>";
var prefix = "<%= prefix %>";
var paramKey = "netui_filter";
var clearAllQuery = "<%= qpOmitFilter %>";
var clearFilterExprQuery = "<%= qpOmitAllFilters %>";
var savedFilter;
var queryStringOmitCurrentColumn = "<%= queryStringOmitCurrentColumn %>";

function doLoad()
{
  alert("do load");
  initFilter();
  alert("end init filter");
  //PlaceCursor();
  //alert("end place cursor");
  //SizeToFit();
  //alert("end size to fit");
}

function initFilter()
{
  var filterForm = document.forms[0];
  alert("filterForm: " + filterForm);

  savedFilter = [selValue(filterForm.filterOp1), filterForm.filterValue1.value, selValue(filterForm.filterOp2), filterForm.filterValue2.value];
  alert(debugFilterArray("saved filter: ", savedFilter));
}

function selValue(sel)
{
  var index = sel.selectedIndex;
  var value = sel.options[index].value;
  return value;
}

function doCancel()
{
  window.close();
  return false;
}

function doClear(clearAll)
{
    var w = window.opener != null ? window.opener : window
    var url = buildURL(w, filterAction, (clearAll == true ? clearAllQuery : clearFilterExprQuery));
    navigate(url);
    return false;
}

function debugFilterArray(msg, ary)
{
    var filterData = msg;
    if(ary == null) return filterData + " empty";

    for(var i = 0; i < ary.length; i++)
    {
        filterData += i + ": " + ary[i] + " ";
    }
    return filterData;
}

function doFilter()
{
    alert("do filter");
    //var filterAry = ["eq", "foo"];
    var filterForm = document.forms[0];

    alert("filterForm: " + filterForm);

    var filterAry = [selValue(filterForm.filterOp1), filterForm.filterValue1.value, selValue(filterForm.filterOp2), filterForm.filterValue2.value];

    alert(debugFilterArray("current filter: ", filterAry));

    var queryParam = buildFilterQueryParam(prefix, filterExpr, filterAry, gridName);
    alert("doFilter.queryParam: " + queryParam);
    var currQueryString = queryStringOmitCurrentColumn; //query string with filters for current column omitted
    var queryString = appendQueryParam(currQueryString, queryParam);

    alert("doFilter.queryString: " + queryString);

    var w = window.opener != null ? window.opener : window
    var url = buildURL(w, filterAction, queryString);
    return navigate(w, url);
}

function navigate(w, url)
{
    alert("navigate window: " + w + " to url: " + url);

    w.location.href = url;
    window.close();
    return false;
}

function buildFilterQueryParam(prefix, filterExpr, filter, gridName) //search,column,filter,gridName)
{
  var queryParam = "";
  numOPs = 0;
  for (i=0 ; i<filter.length ; i+=2)
  {
      if (filter[i] != null && filter[i] != "" && filter[i] != "*") {
	numOPs++;
      }
  }

  //alert("numOPs: " + numOPs);
  numNOPs = 0;
  for (i=0 ; i<filter.length ; i+=2)
  {
      if ((filter[i] == null || filter[i] == "" || filter[i] == "*") && filter[i] != savedFilter[i])
	{
	  numNOPs++;
	  filter[i] = "";
	  if (numOPs != 0 || numNOPs > 1)
	    continue;
	  else
	    filter[i+1] = "*";
	}
      else if (filter[i] == "~isempty" || filter[i] == "~isnotempty")
	filter[i+1] = "1";

      var op = filter[i];
      var value = filter[i+1];

      alert("op: " + op + " value: " + value);

      if (op == null || op == "" || value == null || value == "")
      {
          alert("buildFilterQueryParam.queryParam (no second query): " + queryParam);
          return queryParam;
      }

      if(i > 0) queryParam += "&";

      queryParam = queryParam + paramKey + "=" + encodeURIComponent(gridName + "~" + filterExpr + "~" + op + "~" + value);

      alert("queryParam: " + queryParam);
  }

  return queryParam;
}

function appendQueryParam(queryParams,query)
{
  alert("appendQueryParam: queryParams: " + queryParams + " query: " + query);
  if(queryParams == null || queryParams == "" || queryParams == "?")
    queryParams = "?" + query;
  else if(queryParams.indexOf('?') > -1)
    queryParams = queryParams + "&" + query;
  else queryParams = "?" + queryParams + "&" + query;

  return queryParams;
}

function buildURL(opener, filterAction, queryParams)
{
  var url = "";
  if(filterAction.indexOf("http") == 0)
    url = filterAction + queryParams;
  else url = opener.location.protocol + "//" + opener.location.host + filterAction + queryParams;

  return url;
}

function testBuildQueryParam()
{
  // @todo: build the filter array from the values in the form input fields
  var filterAry = ["eq", "foo"];
  var queryParam = buildFilterQueryParam("", "symbol", filterAry, "portfolio");

  var debugDiv = document.getElementById("debugOutput");
  var textNode = document.createTextNode("queryParam: " + queryParam);
  debugDiv.appendChild(textNode);

  alert("here");
  var search = "?";
  var queryString = appendQueryParam(search, queryParam);
  alert("queryString: " + queryString);
  textNode = document.createTextNode("search: " + queryString);
  debugDiv.appendChild(textNode);

  alert("queryString: " + queryString);

  var w = window.opener != null ? window.opener : window
  var url = buildURL(w, "/dataWeb/basic/filter.do", queryString);
  alert("url: " + url);

  var navigate = true;
  if(navigate)
  {
    w.location.href = url;
    window.close();
  }
}
    </script>
  </head>
  <body onLoad="doLoad();">
<b>Filter Page</b>
<hr/>
<br/>
<form id="frmFilter" onSubmit="return doFilter();">
<table>
<tr><td>Show Records Where</td></tr>
<tr><td><b><netui:label value="{pageContext.filterExpr}"/></b></td></tr>
<tr><td>
  <select name="filterOp1">
    <option value="eq">Equals</option>
    <option value="ne">Does not equal</option>
  </select>
</td></tr>
<tr><td>
    <input type="text" name="filterValue1" value="<%= filter1 != null ? filter1.getValue() : "" %>"/>
</td></tr>
<tr><td>and <b><netui:label value="{pageContext.filterExpr}"/></b></td></tr>
<tr><td>
  <select name="filterOp2">
    <option value="eq">Equals</option>
    <option value="ne">Does not equal</option>
  </select>
</td></tr>
<tr><td>
    <input type="text" name="filterValue2" value="<%= filter2 != null ? filter2.getValue() : "" %>"/>
</td></tr>
<tr>
  <td>
    <input type="submit" name="btnFilter" value="Filter" onfocus="CheckFocus(true);" onblur="CheckFocus(false);"/>
    <input type="submit" name="btnClear" value="Clear" onclick="return doClear();" onfocus="CheckFocus(true);" onblur="CheckFocus(false);"/>
    <input type="submit" name="cmdClearAll" value="Clear All" onclick="return doClear(true);" onfocus="CheckFocus(true);" onblur="CheckFocus(false);"/>
    <input type="submit" name="cmdCancel" value="Cancel" onclick="return doCancel();" onfocus="CheckFocus(true);" onblur="CheckFocus(false);"/>
  </td>
</tr>
</table>
</form>
<br/>
<hr/>
<b>Operations</b>
<br/>
<ul>
<li><a href="javascript:testBuildQueryParam();">Add filter</a></li>
<li>Remove current column filters</li>
<li>Remove all filters</li>
</ul>
<div id="debugOutput">
  Debug output here
</div>
<br/>
<hr/>
<b>Filter Debug</b>
<br/>
Filter expression: <netui:label value="{url._column}"/>
<br/>
Grid namespace: <netui:label value="{url._grid}"/>
<br/>
Query String omit current column filters: <netui:label value="{pageContext.qpOmitFilter}" defaultValue="empty"/>
<br/>
Query String omit all filters: <netui:label value="{pageContext.qpOmitAllFilters}" defaultValue="empty"/>
<br/>
<netui-data:repeater dataSource="{pageContext.filters}" defaultText="No filters">
    <netui-data:repeaterHeader>
        <table>
        <tr><td>Index</td><td>Op</td><td>Expression</td><td>Value</td></tr>
    </netui-data:repeaterHeader>
    <netui-data:repeaterItem>
        <tr>
        <td><netui:label value="{container.index}"/></td>
        <td><netui:label value="{container.item.operation}"/></td>
        <td><netui:label value="{container.item.filterExpression}"/></td>
        <td><netui:label value="{container.item.value}"/></td>
        </tr>
    </netui-data:repeaterItem>
    <netui-data:repeaterFooter></table></netui-data:repeaterFooter>
</netui-data:repeater>
  </body>
</netui:html>
